/************************************************************************/
/*									*/
/* OtBbN (OSˑ)						*/
/*									*/
/*									*/
/* y֐z								*/
/*									*/
/* int  graphic_system_init( void )					*/
/* void graphic_system_term( void )					*/
/* void graphic_system_restart( int redraw_flag )			*/
/* void put_image( void )						*/
/* void trans_palette( SYSTEM_PALETTE_T syspal[] )			*/
/* void set_mouse_visible( void )					*/
/* void set_mouse_invisible( void )					*/
/*									*/
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>	/* maybe not need ... future */
#include <SDL.h>

#include "quasi88.h"
#include "initval.h"
#include "graph.h"
#include "screen.h"
#include "file-op.h"

#include "device.h"


#ifdef USE_DGA
int	use_DGA;			/* tXN[\?	*/
#endif

int	colormap_type   = 0;		/* J[}bṽ^Cv	0/1/2	*/
int	hide_mouse	= FALSE;	/* }EX\邩ǂ	*/
int	grab_mouse	= FALSE;	/* Ou邩ǂ		*/

int	WIDTH  = 0;			/* ʃobt@TCY		*/
int	HEIGHT = 0;			/* ʃobt@cTCY		*/
int	DEPTH  = 16;			/* Frbg	(8 or 16 or 32)	*/
int	SCREEN_W = 0;			/* `GATCY		*/
int	SCREEN_H = 0;			/* `GAcTCY		*/
int	SCREEN_DX = 0;
int	SCREEN_DY = 0;
int	VIEWPORT_W = 0;			/* \GATCY		*/
int	VIEWPORT_H = 0;			/* \GAcTCY		*/
int	VIEWPORT_DX = 0;
int	VIEWPORT_DY = 0;
int	SCREEN_OFFSET;

static	int     SIZE_OF_DEPTH;		/* FoCg	(1 or 2 or 4)	*/

int	screen_size = SCREEN_SIZE_FULL;	/* ʃTCY 0:/1:W/2:{*/
int	screen_size_max = SCREEN_SIZE_FULL;

char	*screen_buf;			/* \pobt@	 	*/
					/* 640x400 or 320x200 or1280x800*/
					/* 8(char)or16(short)or32(long)	*/

char	*screen_start;			/* \obt@`Jnʒu	*/


	Ulong	color_pixel[16];	/* 16pbgpixell	*/
	Ulong	color_half_pixel[16][16];	/* halfTCYp
					 tB^Opbgl	*/



SDL_Surface *display;
SDL_Surface *offscreen;
SDL_Surface *fn_button;

	Ulong    white, black;

static const struct{
  int w, h;
} screen_size_tbl[ END_of_SCREEN_SIZE ] = {
  {  320,  200, },	/* SCREEN_SIZE_HALF	*/
  {  640,  400, },	/* SCREEN_SIZE_FULL	*/
  { 1280,  800, },	/* SCREEN_SIZE_DOUBLE	*/
};

#ifdef	USE_ZAURUS
static const struct{
  int w, h;
} display_size_tbl[ END_of_SCREEN_SIZE ] = {
  {  320,  240, },	/* SCREEN_SIZE_HALF	*/
  {  640,  480, },	/* SCREEN_SIZE_FULL	*/
  { 1280,  960, },	/* SCREEN_SIZE_DOUBLE	*/
};
#endif

/******************************************************************************

                                 WIDTH
	 

	+----------------------------------------------------+
	| VIEWPORT_DY    SCREEN_DY                       |  
	|                                                |  
	|            +------------------------+            |  
	|||            |  
	|VIEWPORT_DX |         VIEWPORT_W     |            |  
	|            |   +------------------+   |            |  
	|||   |            |  
	|    SCREEN_DX   |     SCREEN_W   |   |            |   HEIGHT
	|            |   |                |   |            |  
	|            |   |  SCREEN_H      |   |            |  
	|            |   |                |   |            |  
	|            |   |                |   |            |  
	|            |   +------------------+   |            |  
	|            |                          |c 
       c+--------------------------+            |  
       SCREEN_OFFSET                                         |  
	|                                                    |  
	+----------------------------------------------------+

	WIDTH		mۂOtBbNobt@̉TCY
	HEIGHT		              V              cTCY

	SCREEN_W	`GÃTCY  (320/640/1280̂ꂩ)
	SCREEN_H	        V         c (200/400/ 800̂ꂩ)
	SCREEN_DX	obt@̍[`GA̍[܂ł̋
	SCREEN_DY	    V    [     V     [܂ł̋

	VIEWPORT_W	\GÃTCY 
	VIEWPORT_H	        V         c
	VIEWPORT_DX	obt@̍[\GA̍[܂ł̋
	VIEWPORT_DY	    V    [     V     [܂ł̋

	(ʏ́ASCREEN_*  VIEWPORT_* ͈v)


	SCREEN_OFFSET	`GẢE[A̍[܂ł̋
				= WIDTH - SCREEN_W;
	DEPTH		Fdepth (8/16/32)
	SIZE_OF_DEPTH	log2(DEPTH)/8  = 1/2/4

******************************************************************************/




static int zaurus_mode = FALSE,zaurus_mx = 0,zaurus_my = 0,func_side = 0;

static const char *parse_tilda( const char *fname );

/************************************************************************/
/* OtBbNVXe (X11) ̏					*/
/************************************************************************/
int	graphic_system_init( void )
{
  int ret;


  if( verbose_proc ) printf("Initializing Graphic System (SDL)\n");


	/* fBXvCJ */

  if( verbose_proc ) printf("  Opening display...");
  ret = SDL_Init( SDL_INIT_VIDEO );
  if( ret != 0 ){ if( verbose_proc ) printf("FAILED\n"); return(0); }
  else          { if( verbose_proc ) printf("OK\n");                }

  black = 0;
  white = 0xffffffff;

	/* EChETCYZbg		*/
	/* WIDTH/HEIGHT ̓R}hCŎ擾	*/

  SCREEN_W = screen_size_tbl[screen_size].w;
  SCREEN_H = screen_size_tbl[screen_size].h;
#ifndef	USE_ZAURUS
  if( WIDTH  < SCREEN_W ) WIDTH  = SCREEN_W;
  if( HEIGHT < SCREEN_H ) HEIGHT = SCREEN_H;
#else
  WIDTH = display_size_tbl[screen_size].w;
  HEIGHT = display_size_tbl[screen_size].h;  
#endif
  SCREEN_OFFSET = WIDTH - SCREEN_W;

  SCREEN_DX = ( ( WIDTH - SCREEN_W ) / 2 ) & ~7;	/* 8̔{ */
  SCREEN_DY = ( ( HEIGHT- SCREEN_H ) / 2 ) & ~1;	/* 2̔{ */

  VIEWPORT_W  = WIDTH;
  VIEWPORT_H  = HEIGHT;
  VIEWPORT_DX = 0;
  VIEWPORT_DY = 0;

  /* EChẼ^Cg\ */
  SDL_WM_SetCaption( Q_TITLE " ver " Q_VERSION, Q_TITLE " ver " Q_VERSION );

  /* ACRݒ肷Ȃ炱ŁBWIN32̏ꍇA32x32 Ɍ */
  /* SDL_WM_SetIcon(SDL_Surface *icon, Uint8 *mask); */



  if( use_DGA )					/* tXN[\̏ꍇ */
  display = SDL_SetVideoMode(WIDTH,HEIGHT, 16,
			     SDL_FULLSCREEN|SDL_HWPALETTE|
			     SDL_HWSURFACE|SDL_DOUBLEBUF);
  else						/* EChE\̏ꍇ */
  display = SDL_SetVideoMode(WIDTH,HEIGHT, 16,
			     SDL_HWPALETTE|
			     SDL_HWSURFACE|SDL_DOUBLEBUF);


  if( verbose_proc )
      printf("SDL video %d,%d %d/%d %d %X\n", display->w,display->h,
	     display->format->BitsPerPixel,
	     display->format->BytesPerPixel,
	     display->pitch,display->pixels);
  DEPTH = 16;
  SIZE_OF_DEPTH = 2;

  {
      FILE *mfile;
      char *filename;
      int p1 = 0,p2 = 0,p3 = 0,p4 = 0;

      fn_button = NULL;
      if( WIDTH >= 640 && HEIGHT >= 460 )
      {
	filename = osd_get_home_filename( "fnbtn.bmp", NULL );

	if( filename != NULL ){
	  fn_button = SDL_LoadBMP( filename );
	  if (fn_button ){
	    if( verbose_proc ) printf("loading %s..,OK\n", filename );
	  }
	  ex_free( filename );
	}
      }


      mfile = osd_fopen_rcfile( "mfile.rc", NULL );
      if (mfile != NULL) {
	  fscanf(mfile, "%d,%d,%d,%d", &p1, &p2, &p3, &p4);

	  if( verbose_proc ) printf("Zaurus Ext %d,%d,%d,%d\n", p1,p2,p3,p4);

	  if (p1) {
	      zaurus_mode = TRUE;
	      zaurus_mx = p3;
	      zaurus_my = p4;
	  }

	  func_side = p2;

	  ex_fclose(mfile);
      }
  }

  if (fn_button != NULL){
      SDL_Rect drect = { 0,0,0,0 };
      if (func_side == 0)
	  drect.y = HEIGHT-12-8;
      else
	  drect.y = 8;
      
      SDL_BlitSurface (fn_button, NULL, display, &drect);
  }

  /* XN[obt@m */
  offscreen = SDL_CreateRGBSurface(SDL_SWSURFACE, WIDTH, HEIGHT,
				   16, 0,0,0,0);
  screen_buf = (char *)offscreen->pixels;
  if( verbose_proc ) printf("  Allocating screen buffer...OK\n");


  /* XN[obt@́A`Jnʒuݒ	*/
  
  screen_start = &screen_buf[ (WIDTH*SCREEN_DY + SCREEN_DX) * SIZE_OF_DEPTH ];
  /* screen_start = screen_buf; */
  


	/* ʂxANA */
  screen_buf_init();


	/* X ̃}EXJ[\\^\ݒ */

  if( hide_mouse ) set_mouse_invisible();
  else		   set_mouse_visible();

	/* Ou̐ݒ	*/

  if( grab_mouse ){
    SDL_WM_GrabInput( SDL_GRAB_ON );
  }

  return(1);
}

/************************************************************************/
/* OtBbNVXe (X11) ̏I					*/
/************************************************************************/
void	graphic_system_term( void )
{
    if( grab_mouse ){
      SDL_WM_GrabInput( SDL_GRAB_OFF );
    }

    SDL_Quit();
}



/********************************************************/
/* pbgݒ						*/
/********************************************************/
void	trans_palette( SYSTEM_PALETTE_T syspal[] )
{
  int     i, j;

	/* pbglRs[ */

  for( i=0; i<16; i++ ){
    color_pixel[i] = (((syspal[i].red  >>3)&0x1f) <<11)|
		     (((syspal[i].green>>3)&0x1f) << 6)|
		     (((syspal[i].blue >>3)&0x1f));
  }


	/*  HALF TCYŃtB^O\`FbN */

  if( screen_size == SCREEN_SIZE_HALF &&
/*    grph_ctrl & GRPH_CTRL_COLOR &&  */
      use_half_interp ){
    now_half_interp = TRUE;
  }else{
    now_half_interp = FALSE;
  }

	/* HALFTCYtB^O\̓tB^pbglvZ */

  if( now_half_interp ){
    SYSTEM_PALETTE_T hpal[16];
    for( i=0; i<16; i++ ){
      hpal[i].red   = syspal[i].red   >> 1;
      hpal[i].green = syspal[i].green >> 1;
      hpal[i].blue  = syspal[i].blue  >> 1;
    }

    for( i=0; i<16; i++ ){
      color_half_pixel[i][i] = color_pixel[i];
    }
    for( i=0; i<16; i++ ){
      for( j=i+1; j<16; j++ ){
	color_half_pixel[i][j]=((((hpal[i].red  +hpal[j].red  )>>3)&0x1f)<<11)|
			       ((((hpal[i].green+hpal[j].green)>>3)&0x1f)<< 6)|
			       ((((hpal[i].blue +hpal[j].blue )>>3)&0x1f));
	color_half_pixel[j][i] = color_half_pixel[i][j];
      }
    }
  }
}




/************************************************************************/
/* ʕ\								*/
/************************************************************************/
void	put_image( void )
{
  Uint16 *buf = (Uint16 *)screen_buf;

  SDL_Rect srect = { 0,0,0,0 };
  SDL_Rect drect = { 0,0,0,0 };

  srect.x = SCREEN_DX;	srect.w = SCREEN_W;
  srect.y = SCREEN_DY;  srect.h = SCREEN_H;
  drect.x = SCREEN_DX;
  drect.y = SCREEN_DY;

  if(SDL_BlitSurface (offscreen, &srect, display, &drect)<0) 
      fprintf (stderr,"SDL: Warn: Unsuccessful blitting\n");

  /* SDL_UpdateRect(display, 0,0,0,0); */
  SDL_Flip(display);
}






/************************************************************************/
/* }EX̕\^\sȂ֐					*/
/************************************************************************/
void	set_mouse_visible( void )
{
  SDL_ShowCursor( SDL_ENABLE );
}

void	set_mouse_invisible( void )
{
  SDL_ShowCursor( SDL_DISABLE );
}



/************************************************************************/
/* OtBbNVXe (X11) ̍ď				*/
/*	OtBbNVXeUIAēxAsB		*/
/*	OāAscreen_size ȂǂύXĂ΁AVȑ傫	*/
/*	EChE邱ƂɂȂB				*/
/*	ďɎsƂ́Aǂ悤Ȃ̂ŁAIB	*/
/************************************************************************/
void	graphic_system_restart( int redraw_flag )
{
#if 0
  if( ! SDL_WM_ToggleFullScreen( display ) ){
    if( verbose_proc ) printf("Can't toggle full screen\n" );
  }
#endif

  int	verbose_proc_saved = verbose_proc;
  verbose_proc = 0;

  /* OtBbNVXeUI */
  /*graphic_system_term();*/
  SDL_QuitSubSystem( SDL_INIT_VIDEO );



  /* EChEĐɁA{[_[̃TCYɂȂ悤ɂ */
#ifndef	USE_ZAURUS
  WIDTH  = SCREEN_DX * 2 + screen_size_tbl[screen_size].w;
  HEIGHT = SCREEN_DY * 2 + screen_size_tbl[screen_size].h;
#else
  WIDTH = display_size_tbl[screen_size].w;
  HEIGHT = display_size_tbl[screen_size].h;  
#endif


  if( graphic_system_init() ){

    verbose_proc = verbose_proc_saved;
    if( redraw_flag ) redraw_screen( FALSE );

  }else{

    fprintf(stderr,"Sorry : Graphic System Fatal Error !!!\n");

    verbose_proc = verbose_proc_saved;
    main_exit(-1);

  }
}








int function_mouse_pos(int x, int y)
{
    int fn = -1;
    int xx = x-32,yy;

    if ( fn_button ){
      if (func_side == 0)
	yy = y - (HEIGHT-12-8);
      else
	yy = y - 8;

      if (xx >= 0 && xx <= 12*48 && yy >= 0 && yy <=12){
	fn = xx / 48;
      }
    }
    return fn;
}

void mouse_coord_trans(int x, int y, int *mx, int *my)
{
    if (!zaurus_mode) {
	*mx = x;
	*my = y;
    } else {
	*mx = (WIDTH  - x) - zaurus_mx;
	*my = (HEIGHT - y) - zaurus_my;
    }
}

