#ifndef Z80_H_INCLUDED
#define Z80_H_INCLUDED



/* --- Z80 CPU ̃G~[g\ --- */

typedef struct{

  pair	AF, BC, DE, HL;			/* ėpWX^ */
  pair	IX, IY, PC, SP;			/* pWX^ */
  pair	AF1,BC1,DE1,HL1;		/*   WX^	*/
  byte	I, R;				/* ꃌWX^ */
  byte	R_saved;			/* R reg ۑp */
  Uchar	IFF,IFF2;			/* IFF1 AIFF2	*/
  Uchar	IM;				/* [h	*/
  Uchar	HALT;				/* HALT tO	*/
  Uchar	discontinue;			/* ꒆf */

  int	icount;				/* 荞ݔ܂ł̃Xe[g */
  int	state;				/* ߂̑Xe[g	*/
  int	state0;				/*		V		*/


  Uchar	log;				/* ^ȂfobOp̃OL^	*/
  Uchar	break_if_halt;			/* HALTɏ[v狭Eo*/

  byte	(*mem_read)(word);		/* [h֐	*/
  void	(*mem_write)(word,byte);	/* Cg֐	*/
  byte	(*io_read)(byte);		/* I/O ͊֐		*/
  void	(*io_write)(byte,byte);		/* I/O o͊֐		*/

  int	(*intr_update)(void);		/* XV֐	*/
  int	(*intr_chk)(void);		/* `FbN֐	*/

  pair  PC_prev;			/* O PC (j^p)	*/

} z80arch;


/* z80arch ̊eR[obN֐ɂāA
   state + state0 ݂܂łɏ Xe[gƂȂB */




/* IFF ̒g */
#define INT_DISABLE	(0)
#define INT_ENABLE	(1)




extern	void	z80_reset( z80arch *z80 );
extern	int	z80_emu( z80arch *z80, int state_of_exec );
extern	void	z80_debug( z80arch *z80, char *mes );
extern	int	z80_line_disasm( z80arch *z80, word addr );

extern	void	z80_logging( z80arch *z80 );



extern	int	highspeed_flag;

#define	refresh_intr_timing( z80 )	if(highspeed_flag==FALSE) z80.icount=0
#define	set_cpu_dormant( z80 )		z80.icount = 0
					    

#endif		/* Z80_H_INCLUDED */
